"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportEventEntry(ProtocolElement):
    """
    A variant or variants (i.e.: composite heterozygous) reported by any
    manual or automated means. The information about the report is
    contained within a ReportEvent, it is linked to one or more
    ObservedVariant.  Every ReportedVariant is uniquely identified by:
    * report event id * report model version * id * version * family
    id * cohort id * variants identifiers (being a variant identifier
    formed by chromosome + position + reference + alternate)
    Duplication of the prior fields is not be supported.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "author",
        "cohortId",
        "date",
        "groupId",
        "id",
        "program",
        "reportModelVersion",
        "type",
        "variantId",
        "version",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import cva as cva_1_5_3
        from protocols.protocol_7_10 import reports as reports_6_4_0

        return {
            "additionalProperties": reports_6_4_0.Property,
            "comments": cva_1_5_3.Comment,
            "observedVariants": cva_1_5_3.ObservedVariant,
            "reportEvent": reports_6_4_0.ReportEvent,
            "reportEventQuestionnaire": cva_1_5_3.ReportEventQuestionnaireRD,
            "reportEventQuestionnaireCancer": cva_1_5_3.ReportEventQuestionnaireCancer,
            "variant": cva_1_5_3.Variant,
            "variantAttributes": reports_6_4_0.VariantAttributes,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import cva as cva_1_5_3
        from protocols.protocol_7_10 import reports as reports_6_4_0

        return {
            "program": reports_6_4_0.Program,
            "type": cva_1_5_3.ReportEventType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import cva as cva_1_5_3
        from protocols.protocol_7_10 import opencb as opencb_1_3_0
        from protocols.protocol_7_10 import reports as reports_6_4_0

        return {
            "org.opencb.biodata.models.variant.avro.Property": opencb_1_3_0.Property,
            "org.gel.models.cva.avro.Comment": cva_1_5_3.Comment,
            "org.gel.models.cva.avro.ObservedVariant": cva_1_5_3.ObservedVariant,
            "org.gel.models.report.avro.Program": reports_6_4_0.Program,
            "org.gel.models.report.avro.ReportEvent": reports_6_4_0.ReportEvent,
            "org.gel.models.cva.avro.ReportEventQuestionnaireRD": cva_1_5_3.ReportEventQuestionnaireRD,
            "org.gel.models.cva.avro.ReportEventQuestionnaireCancer": cva_1_5_3.ReportEventQuestionnaireCancer,
            "org.gel.models.cva.avro.ReportEventType": cva_1_5_3.ReportEventType,
            "org.gel.models.cva.avro.Variant": cva_1_5_3.Variant,
            "org.gel.models.report.avro.VariantAttributes": reports_6_4_0.VariantAttributes,
            "org.gel.models.cva.avro.ReportEventEntry": cva_1_5_3.ReportEventEntry,
        }

    __slots__ = [
        "author",
        "cohortId",
        "date",
        "groupId",
        "id",
        "program",
        "reportModelVersion",
        "type",
        "variantId",
        "version",
        "additionalProperties",
        "authorVersion",
        "caseId",
        "caseVersion",
        "comments",
        "compoundHeterozygousVariantId",
        "latest",
        "observedVariants",
        "reportEvent",
        "reportEventQuestionnaire",
        "reportEventQuestionnaireCancer",
        "validated",
        "variant",
        "variantAttributes",
        "workspace",
    ]

    def __init__(
        self,
        author,
        cohortId,
        date,
        groupId,
        id,
        program,
        reportModelVersion,
        type,
        variantId,
        version,
        additionalProperties=list,
        authorVersion=None,
        caseId=None,
        caseVersion=None,
        comments=list,
        compoundHeterozygousVariantId=None,
        latest=None,
        observedVariants=list,
        reportEvent=None,
        reportEventQuestionnaire=None,
        reportEventQuestionnaireCancer=None,
        validated=False,
        variant=None,
        variantAttributes=None,
        workspace=list,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.ReportEventEntry model.

        :param author:
            The author of the ReportedVariant, either tiering, exomiser, a given
            cip (e.g.: omicia) or a given GMCs user name
        :type author: str
        :param cohortId:
            The cohort identifier (the same family can have several cohorts)
        :type cohortId: str
        :param date:
            Date in format yyyyMMddhhmm
        :type date: str
        :param groupId:
            The group identifier, either a family identifier for RD or a
            participant id for cancer
        :type groupId: str
        :param id:
            The identifier for the higher level entity, either
            InterpretationRequest, InterpretedGenome or ClinicalReport
        :type id: str
        :param program:
            The 100K Genomes program to which the reported variant belongs.
        :type program: Program
        :param reportModelVersion:
            Report avro models version
        :type reportModelVersion: str
        :param type:
            Type of ReportedVariant
        :type type: ReportEventType
        :param variantId:
            The variant id *
        :type variantId: str
        :param version:
            The version for the higher level entity, either InterpretationRequest,
            InterpretedGenome or ClinicalReport
        :type version: int
        :param additionalProperties:
            A list of additional properties in the form name-value.
        :type additionalProperties: list[Property]
        :param authorVersion:
            The author version of the ReportedVariant, either tiering, exomiser or
            a given cip. Only applicable for automated processes.
        :type authorVersion: None | str
        :param caseId:
            The identifier for the InterpretationRequest
        :type caseId: None | str
        :param caseVersion:
            The version for the InterpretationRequest
        :type caseVersion: None | int
        :param comments:
            Comments for this diagnostic event
        :type comments: list[Comment]
        :param compoundHeterozygousVariantId:
            The id of the combined compound heterozygous variants if present *
        :type compoundHeterozygousVariantId: None | str
        :param latest:
            A flag to indicate that this report event corresponds to the latest
            interpretation of the same case as defined by the highest
            `version`
        :type latest: None | boolean
        :param observedVariants:
            The observed variants
        :type observedVariants: list[ObservedVariant]
        :param reportEvent:
            The report event for the rare disease program
        :type reportEvent: None | ReportEvent
        :param reportEventQuestionnaire:
            The report event for the questionnaire reports in the rare disease
            program
        :type reportEventQuestionnaire: None | ReportEventQuestionnaireRD
        :param reportEventQuestionnaireCancer:
            The report event for the questionnaire reports in the cancer program
        :type reportEventQuestionnaireCancer: None | ReportEventQuestionnaireCancer
        :param validated:
            Validation flag
        :type validated: boolean
        :param variant:
            The abstract variant (NOTE: this should not be nullable once the
            Variant is removed from the list of observed variants)
        :type variant: None | Variant
        :param variantAttributes:
            Additional variant attributes
        :type variantAttributes: None | VariantAttributes
        :param workspace:
            The workspace. This field is used to control authorisation to access
            each case.
        :type workspace: list[str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
